<template>
<div class="container">
        <product-header
            v-bind:count="filteredList.length"
            v-bind:showSaleItem="showSaleItem"
            v-bind:showDelvFree="showDelvFree" 
            v-bind:sortOrder="sortOrder" 
            v-on:showSaleItemChanged="showSaleItem=!showSaleItem" 
            v-on:showDelvFreeChanged="showDelvFree=!showDelvFree" 
            v-on:sortOrderChanged="sortOrderChanged">
        </product-header>
        <div class="list">
            <product
                v-for="product in filteredList"
                v-bind:product="product"
                v-bind:key="product.id">
            </product>
        </div>
    </div>
</template>

<script>
import productHeader from './product-header'
import product from './product'

export default {
    name:'productList',
    props:['products'],
    components:{
        'product-header':productHeader,
        'product':product
    },
    data:function(){
        return{
                // セール対象のチェック状態  
            showSaleItem: false,
            showDelvFree: false,
            sortOrder: 1
        }
    },
    methods: {
        // 並び替えの選択肢が変わった時呼び出されるメソッド  
        sortOrderChanged: function(order) {
            // 現在の選択値を新しい選択値で上書きする  
            this.sortOrder = order;
        }
    },
    computed: {
        // 絞り込み後の商品リストを返す算出プロパティ  
        filteredList: function() {
            // 絞り込み後の商品リストを格納する新しい配列  
            var newList = [];
            console.log(this.showSaleItem);
            for (var i = 0; i < this.products.length; i++) {
                // 表示対象かどうかを判定するフラグ  
                var isShow = true;
                // i番目の商品が表示対象かどうかを判定する  
                if (this.showSaleItem && !this.products[i].isSale) {
                    // セール対象を表示する状態で、セール対象商品では無い場合  
                    console.log(this.products[i].isSale);
                    isShow = false;

                }
                if (this.showDelvFree && this.products[i].delv > 0) {
                    // 送料無料を表示する状態で、送料有りの状態の場合  
                    console.log(this.products[i].delv);
                    isShow = false;
                }
                if (isShow) {
                    newList.push(this.products[i]);
                }
            }
            if (this.sortOrder == 2) {
                // 価格が安い順に並び替える  

                newList.sort(function(a, b) {
                    return a.price - b.price;
                });
            }
            // 絞り込み後のリストを返す  
            return newList;

        }
    }

}
</script>

<!-- CSSのスコープをコンポーネント内でのみ有効としたい場合はscoped属性を付ける-->
<style scoped>
    .container {
    width: 960px;
    margin: 0 auto;
}

.list {
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
}

.list::after {
    content: "";
    display: block;
    width: 250px;
}
</style>

